import jsonpath
import json

from Common.handle_envdata import EnvData
from Common.my_logger import logger


def extract_data_from_response(extract_exprs, response_dict):
    """
    根据jsonpath提取表达式，从响应结果当中，提取数据并设置为环境变量EnvData类的类属性，作为全局变量使用。
    :param extract_exprs: 从excel当中读取出来的，提取表达式的字符串。
    :param response_dict: http请求之后的响应结果。
    :return:Nonoe
    """
    # 将提取表达式转换成字典
    extract_dict = eval(extract_exprs)
    logger.info("要从响应结果当中提取的数据集为：\n{}".format(extract_dict))
    # 遍历字典，key作为全局变量名，value是jsonpath提取表达式。
    for key, value in extract_dict.items():
        # 提取
        res = str(jsonpath.jsonpath(response_dict, value)[0])
        # 设置环境变量
        logger.info("设置环境变量 {}：{}".format(key, res))
        setattr(EnvData, key, res)


if __name__ == '__main__':
    ss = '{"token":"$..token"}'
    response = {
        "code": 200,
        "msg": "登录成功",
        "data": {
            "token": "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJodHRwOi8vZ2FsYXh5X3VzZXJfbWljcm9zOjkzMDQvYWRtaW5pc3RyYXRvci9hdXRoL2xvZ2luIiwiaWF0IjoxNjkzOTgwNzU0LCJleHAiOjE2OTQ1ODU1NTQsIm5iZiI6MTY5Mzk4MDc1NCwianRpIjoiZEJWOWtab2V2M0tZZ2FydyIsInN1YiI6MSwicHJ2IjoiMjNiZDVjODk0OWY2MDBhZGIzOWU3MDFjNDAwODcyZGI3YTU5NzZmNyJ9.t1LxoPX3Ec8xUZ5mNmLurI0UJ1tUeL9SQHI50gJh2PU",
            "expires_in": 604800,
            "user": {
                "id": 1,
                "company": "SZ",
                "account": "admin0001",
                "name": "技术测试账号1",
                "email": "",
                "next_online_datetime": None,
                "leave_time": None,
                "online_status": 2,
                "is_leader": 0,
                "leader_path": "1533,",
                "leader_id": 1533,
                "english_name": "admin0001",
                "status": 1,
                "avatar": "https://upload.cdn.galaxy-immi.com/crm/test/images/1681438465044.png",
                "created_at": "2021-02-24 06:43:53",
                "updated_at": "2023-09-06 14:09:28",
                "wework_key": "13627097804",
                "login_at": "2023-09-06 14:09:28",
                "wework_name": "Richard余志钊",
                "mobile": "13699999999",
                "mobile2": "",
                "scrm_id": "63",
                "scrm_wx_id": "f34bb86f8b9b4f96a9d61c38525a89c8",
                "is_new_employee": 1,
                "head_image": "",
                "wx_image": "",
                "is_new_owner": 0,
                "is_new_charge": 1,
                "is_new_charge_business": 1,
                "is_new_owner_business": 1,
                "wx_qrcode": "https://upload.cdn.galaxy-immi.com/crm/test/images/1688459127787.png",
                "green_wx_qrcode": "https://upload.cdn.galaxy-immi.com/crm/test/images/1688459095787.png",
                "wechat_wise_openid": "",
                "wechat_wise_unionid": "",
                "update_password_at": "2023-07-07 17:41:15",
                "try_times": 0,
                "login_fail_times": 0,
                "login_fail_times_limit": 100,
                "department_id": 141,
                "department_name": "测试部",
                "jump": "/Information/ClientCenter",
                "handle": 0,
                "rolesname": "超级管理员",
                "status_cn": "使用中"
            }
        }
    }

    extract_data_from_response(ss, response)
    print(EnvData.__dict__)
